unit book_search;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Data.OleDb, System.Resources;

type
  Tbook_search = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    components: System.ComponentModel.IContainer;
    Panel1: System.Windows.Forms.Panel;
    Panel4: System.Windows.Forms.Panel;
    chk_allbook: System.Windows.Forms.CheckBox;
    lall_invoice: System.Windows.Forms.Label;
    Panel3: System.Windows.Forms.Panel;
    txtsearch: System.Windows.Forms.TextBox;
    Btnsearch: System.Windows.Forms.Button;
    Panel2: System.Windows.Forms.Panel;
    cmbfather: System.Windows.Forms.ComboBox;
    cmbfirst: System.Windows.Forms.ComboBox;
    Btnclear: System.Windows.Forms.Button;
    lphoneno: System.Windows.Forms.Label;
    lcity: System.Windows.Forms.Label;
    lcountry: System.Windows.Forms.Label;
    txtphone: System.Windows.Forms.TextBox;
    lfather: System.Windows.Forms.Label;
    lfirst: System.Windows.Forms.Label;
    lname: System.Windows.Forms.Label;
    cmbname: System.Windows.Forms.ComboBox;
    cmbcity: System.Windows.Forms.ComboBox;
    cmbcountry: System.Windows.Forms.ComboBox;
    Label1: System.Windows.Forms.Label;
    Chkcond: System.Windows.Forms.CheckBox;
    lcondition: System.Windows.Forms.Label;
    lbfound: System.Windows.Forms.Label;
    DataGrid1: System.Windows.Forms.DataGrid;
    Panel5: System.Windows.Forms.Panel;
    Btnok: System.Windows.Forms.Button;
    Btncancel: System.Windows.Forms.Button;
    ImageList1: System.Windows.Forms.ImageList;
    OleDbConnection1: System.Data.OleDb.OleDbConnection;
    DataGridTableStyle1: System.Windows.Forms.DataGridTableStyle;
    DataGridTextBoxColumn1: System.Windows.Forms.DataGridTextBoxColumn;
    DataGridTextBoxColumn2: System.Windows.Forms.DataGridTextBoxColumn;
    DataGridTextBoxColumn3: System.Windows.Forms.DataGridTextBoxColumn;
    DataGridTextBoxColumn4: System.Windows.Forms.DataGridTextBoxColumn;
    DataGridTextBoxColumn5: System.Windows.Forms.DataGridTextBoxColumn;
    Pic_line011: System.Windows.Forms.PictureBox;
    Pic_line012: System.Windows.Forms.PictureBox;
    Pic_line013: System.Windows.Forms.PictureBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure Tbook_search_Load(sender: System.Object; e: System.EventArgs);
    procedure chk_allbook_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure cmbname_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure cmbfirst_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure cmbfather_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure cmbcountry_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure cmbcity_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure txtphone_KeyPress(sender: System.Object; e: System.Windows.Forms.KeyPressEventArgs);
    procedure Btnclear_Click(sender: System.Object; e: System.EventArgs);
    procedure Btnsearch_Click(sender: System.Object; e: System.EventArgs);
    procedure Btnok_Click(sender: System.Object; e: System.EventArgs);
    procedure Btncancel_Click(sender: System.Object; e: System.EventArgs);
    procedure Chkcond_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure DataGrid1_Click(sender: System.Object; e: System.EventArgs);
    procedure DataGrid1_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    procedure sub_load(v_field: string);
    procedure sub_check;
    procedure sub_clearall;
    procedure sub_search(v_name: string; v_firstname: string; v_fathername: string; v_country: string; v_city: string; v_phone: string);
    procedure sub_select;
  public
    constructor Create;
      class function Showbooksearch: System.Windows.Forms.DialogResult;
    class function book_v_recno: Integer;
    class function book_findedit_Flag: string;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(Tbook_search))]

implementation
uses
  book_note;
 var
 vselect: System.Data.OleDb.OleDbCommand;
 vda: System.Data.OleDb.OleDbDataAdapter;
 vdset: System.Data.DataSet;

 vitem_grid: string;
 findedit_Flag: string;
 s_flag: Boolean;
 searchflg: Boolean;
 v_recno: Integer;

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure Tbook_search.InitializeComponent;
type
  TSystem_Windows_Forms_DataGridTableStyleArray = array of System.Windows.Forms.DataGridTableStyle;
  TSystem_Windows_Forms_DataGridColumnStyleArray = array of System.Windows.Forms.DataGridColumnStyle;
  TSystem_ObjectArray = array of System.Object;
var
  resources: System.Resources.ResourceManager;
begin
  Self.components := System.ComponentModel.Container.Create;
  resources := System.Resources.ResourceManager.Create(TypeOf(Tbook_search));
  Self.Panel1 := System.Windows.Forms.Panel.Create;
  Self.Panel5 := System.Windows.Forms.Panel.Create;
  Self.Pic_line013 := System.Windows.Forms.PictureBox.Create;
  Self.Pic_line012 := System.Windows.Forms.PictureBox.Create;
  Self.Pic_line011 := System.Windows.Forms.PictureBox.Create;
  Self.Btnok := System.Windows.Forms.Button.Create;
  Self.ImageList1 := System.Windows.Forms.ImageList.Create(Self.components);
  Self.Btncancel := System.Windows.Forms.Button.Create;
  Self.DataGrid1 := System.Windows.Forms.DataGrid.Create;
  Self.DataGridTableStyle1 := System.Windows.Forms.DataGridTableStyle.Create;
  Self.DataGridTextBoxColumn1 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.DataGridTextBoxColumn2 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.DataGridTextBoxColumn3 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.DataGridTextBoxColumn4 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.DataGridTextBoxColumn5 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.lbfound := System.Windows.Forms.Label.Create;
  Self.Label1 := System.Windows.Forms.Label.Create;
  Self.Panel4 := System.Windows.Forms.Panel.Create;
  Self.chk_allbook := System.Windows.Forms.CheckBox.Create;
  Self.lall_invoice := System.Windows.Forms.Label.Create;
  Self.Panel3 := System.Windows.Forms.Panel.Create;
  Self.txtsearch := System.Windows.Forms.TextBox.Create;
  Self.Btnsearch := System.Windows.Forms.Button.Create;
  Self.Panel2 := System.Windows.Forms.Panel.Create;
  Self.lcondition := System.Windows.Forms.Label.Create;
  Self.Chkcond := System.Windows.Forms.CheckBox.Create;
  Self.cmbfather := System.Windows.Forms.ComboBox.Create;
  Self.cmbfirst := System.Windows.Forms.ComboBox.Create;
  Self.Btnclear := System.Windows.Forms.Button.Create;
  Self.lphoneno := System.Windows.Forms.Label.Create;
  Self.lcity := System.Windows.Forms.Label.Create;
  Self.lcountry := System.Windows.Forms.Label.Create;
  Self.txtphone := System.Windows.Forms.TextBox.Create;
  Self.lfather := System.Windows.Forms.Label.Create;
  Self.lfirst := System.Windows.Forms.Label.Create;
  Self.lname := System.Windows.Forms.Label.Create;
  Self.cmbname := System.Windows.Forms.ComboBox.Create;
  Self.cmbcity := System.Windows.Forms.ComboBox.Create;
  Self.cmbcountry := System.Windows.Forms.ComboBox.Create;
  Self.OleDbConnection1 := System.Data.OleDb.OleDbConnection.Create;
  Self.Panel1.SuspendLayout;
  Self.Panel5.SuspendLayout;
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).BeginInit;
  Self.Panel4.SuspendLayout;
  Self.Panel3.SuspendLayout;
  Self.Panel2.SuspendLayout;
  Self.SuspendLayout;
  // 
  // Panel1
  // 
  Self.Panel1.BackColor := System.Drawing.Color.LightCyan;
  Self.Panel1.Controls.Add(Self.Panel5);
  Self.Panel1.Controls.Add(Self.DataGrid1);
  Self.Panel1.Controls.Add(Self.lbfound);
  Self.Panel1.Controls.Add(Self.Label1);
  Self.Panel1.Controls.Add(Self.Panel4);
  Self.Panel1.Controls.Add(Self.Panel3);
  Self.Panel1.Controls.Add(Self.Panel2);
  Self.Panel1.Location := System.Drawing.Point.Create(8, 8);
  Self.Panel1.Name := 'Panel1';
  Self.Panel1.Size := System.Drawing.Size.Create(648, 412);
  Self.Panel1.TabIndex := 0;
  // 
  // Panel5
  // 
  Self.Panel5.BackColor := System.Drawing.SystemColors.AppWorkspace;
  Self.Panel5.Controls.Add(Self.Pic_line013);
  Self.Panel5.Controls.Add(Self.Pic_line012);
  Self.Panel5.Controls.Add(Self.Pic_line011);
  Self.Panel5.Controls.Add(Self.Btnok);
  Self.Panel5.Controls.Add(Self.Btncancel);
  Self.Panel5.Location := System.Drawing.Point.Create(8, 368);
  Self.Panel5.Name := 'Panel5';
  Self.Panel5.Size := System.Drawing.Size.Create(632, 36);
  Self.Panel5.TabIndex := 0;
  // 
  // Pic_line013
  // 
  Self.Pic_line013.Image := (System.Drawing.Image(resources.GetObject('Pic_line013.Image')));
  Self.Pic_line013.Location := System.Drawing.Point.Create(16, 24);
  Self.Pic_line013.Name := 'Pic_line013';
  Self.Pic_line013.Size := System.Drawing.Size.Create(450, 2);
  Self.Pic_line013.SizeMode := System.Windows.Forms.PictureBoxSizeMode.AutoSize;
  Self.Pic_line013.TabIndex := 4;
  Self.Pic_line013.TabStop := False;
  // 
  // Pic_line012
  // 
  Self.Pic_line012.Image := (System.Drawing.Image(resources.GetObject('Pic_line012.Image')));
  Self.Pic_line012.Location := System.Drawing.Point.Create(16, 16);
  Self.Pic_line012.Name := 'Pic_line012';
  Self.Pic_line012.Size := System.Drawing.Size.Create(450, 2);
  Self.Pic_line012.SizeMode := System.Windows.Forms.PictureBoxSizeMode.AutoSize;
  Self.Pic_line012.TabIndex := 3;
  Self.Pic_line012.TabStop := False;
  // 
  // Pic_line011
  // 
  Self.Pic_line011.Image := (System.Drawing.Image(resources.GetObject('Pic_line011.Image')));
  Self.Pic_line011.Location := System.Drawing.Point.Create(16, 8);
  Self.Pic_line011.Name := 'Pic_line011';
  Self.Pic_line011.Size := System.Drawing.Size.Create(450, 2);
  Self.Pic_line011.SizeMode := System.Windows.Forms.PictureBoxSizeMode.AutoSize;
  Self.Pic_line011.TabIndex := 2;
  Self.Pic_line011.TabStop := False;
  // 
  // Btnok
  // 
  Self.Btnok.Enabled := False;
  Self.Btnok.ImageIndex := 0;
  Self.Btnok.ImageList := Self.ImageList1;
  Self.Btnok.Location := System.Drawing.Point.Create(480, 6);
  Self.Btnok.Name := 'Btnok';
  Self.Btnok.Size := System.Drawing.Size.Create(64, 20);
  Self.Btnok.TabIndex := 1;
  Include(Self.Btnok.Click, Self.Btnok_Click);
  // 
  // ImageList1
  // 
  Self.ImageList1.ImageSize := System.Drawing.Size.Create(65, 20);
  Self.ImageList1.ImageStream := (System.Windows.Forms.ImageListStreamer(resources.GetObject('ImageList1.ImageStream')));
  Self.ImageList1.TransparentColor := System.Drawing.Color.Transparent;
  // 
  // Btncancel
  // 
  Self.Btncancel.ImageIndex := 1;
  Self.Btncancel.ImageList := Self.ImageList1;
  Self.Btncancel.Location := System.Drawing.Point.Create(560, 6);
  Self.Btncancel.Name := 'Btncancel';
  Self.Btncancel.Size := System.Drawing.Size.Create(64, 20);
  Self.Btncancel.TabIndex := 0;
  Include(Self.Btncancel.Click, Self.Btncancel_Click);
  // 
  // DataGrid1
  // 
  Self.DataGrid1.BorderStyle := System.Windows.Forms.BorderStyle.None;
  Self.DataGrid1.DataMember := '';
  Self.DataGrid1.HeaderForeColor := System.Drawing.SystemColors.ControlText;
  Self.DataGrid1.Location := System.Drawing.Point.Create(200, 24);
  Self.DataGrid1.Name := 'DataGrid1';
  Self.DataGrid1.ReadOnly := True;
  Self.DataGrid1.Size := System.Drawing.Size.Create(440, 336);
  Self.DataGrid1.TabIndex := 1;
  Self.DataGrid1.TableStyles.AddRange(TSystem_Windows_Forms_DataGridTableStyleArray.Create(Self.DataGridTableStyle1));
  Include(Self.DataGrid1.Click, Self.DataGrid1_Click);
  Include(Self.DataGrid1.MouseUp, Self.DataGrid1_MouseUp);
  // 
  // DataGridTableStyle1
  // 
  Self.DataGridTableStyle1.DataGrid := Self.DataGrid1;
  Self.DataGridTableStyle1.GridColumnStyles.AddRange(TSystem_Windows_Forms_DataGridColumnStyleArray.Create(Self.DataGridTextBoxColumn1, 
          Self.DataGridTextBoxColumn2, Self.DataGridTextBoxColumn3, Self.DataGridTextBoxColumn4, 
          Self.DataGridTextBoxColumn5));
  Self.DataGridTableStyle1.HeaderForeColor := System.Drawing.SystemColors.ControlText;
  Self.DataGridTableStyle1.MappingName := 'book';
  // 
  // DataGridTextBoxColumn1
  // 
  Self.DataGridTextBoxColumn1.Format := '';
  Self.DataGridTextBoxColumn1.FormatInfo := nil;
  Self.DataGridTextBoxColumn1.HeaderText := 'id';
  Self.DataGridTextBoxColumn1.MappingName := 'bookid';
  Self.DataGridTextBoxColumn1.NullText := '';
  Self.DataGridTextBoxColumn1.Width := 30;
  // 
  // DataGridTextBoxColumn2
  // 
  Self.DataGridTextBoxColumn2.Format := '';
  Self.DataGridTextBoxColumn2.FormatInfo := nil;
  Self.DataGridTextBoxColumn2.HeaderText := 'name';
  Self.DataGridTextBoxColumn2.MappingName := 'name';
  Self.DataGridTextBoxColumn2.NullText := '';
  Self.DataGridTextBoxColumn2.Width := 75;
  // 
  // DataGridTextBoxColumn3
  // 
  Self.DataGridTextBoxColumn3.Format := '';
  Self.DataGridTextBoxColumn3.FormatInfo := nil;
  Self.DataGridTextBoxColumn3.HeaderText := 'first name';
  Self.DataGridTextBoxColumn3.MappingName := 'first_name';
  Self.DataGridTextBoxColumn3.NullText := '';
  Self.DataGridTextBoxColumn3.Width := 90;
  // 
  // DataGridTextBoxColumn4
  // 
  Self.DataGridTextBoxColumn4.Format := '';
  Self.DataGridTextBoxColumn4.FormatInfo := nil;
  Self.DataGridTextBoxColumn4.HeaderText := 'father name';
  Self.DataGridTextBoxColumn4.MappingName := 'father_name';
  Self.DataGridTextBoxColumn4.NullText := '';
  Self.DataGridTextBoxColumn4.Width := 90;
  // 
  // DataGridTextBoxColumn5
  // 
  Self.DataGridTextBoxColumn5.Format := '';
  Self.DataGridTextBoxColumn5.FormatInfo := nil;
  Self.DataGridTextBoxColumn5.HeaderText := 'country';
  Self.DataGridTextBoxColumn5.MappingName := 'country';
  Self.DataGridTextBoxColumn5.NullText := '';
  Self.DataGridTextBoxColumn5.Width := 80;
  // 
  // lbfound
  // 
  Self.lbfound.Font := System.Drawing.Font.Create('Times New Roman', 9, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lbfound.Location := System.Drawing.Point.Create(164, 5);
  Self.lbfound.Name := 'lbfound';
  Self.lbfound.Size := System.Drawing.Size.Create(440, 16);
  Self.lbfound.TabIndex := 2;
  Self.lbfound.Text := 'item(s) found ???';
  Self.lbfound.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
  // 
  // Label1
  // 
  Self.Label1.Font := System.Drawing.Font.Create('Times New Roman', 12, (System.Drawing.FontStyle((System.Drawing.FontStyle.Bold 
      or System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, 
      (Byte(178)));
  Self.Label1.ForeColor := System.Drawing.Color.Navy;
  Self.Label1.Location := System.Drawing.Point.Create(0, 6);
  Self.Label1.Name := 'Label1';
  Self.Label1.Size := System.Drawing.Size.Create(80, 16);
  Self.Label1.TabIndex := 4;
  Self.Label1.Text := 'Search in';
  Self.Label1.TextAlign := System.Drawing.ContentAlignment.MiddleRight;
  // 
  // Panel4
  // 
  Self.Panel4.BackColor := System.Drawing.SystemColors.Control;
  Self.Panel4.Controls.Add(Self.chk_allbook);
  Self.Panel4.Controls.Add(Self.lall_invoice);
  Self.Panel4.Location := System.Drawing.Point.Create(8, 24);
  Self.Panel4.Name := 'Panel4';
  Self.Panel4.Size := System.Drawing.Size.Create(144, 24);
  Self.Panel4.TabIndex := 5;
  // 
  // chk_allbook
  // 
  Self.chk_allbook.Location := System.Drawing.Point.Create(8, 4);
  Self.chk_allbook.Name := 'chk_allbook';
  Self.chk_allbook.Size := System.Drawing.Size.Create(16, 16);
  Self.chk_allbook.TabIndex := 0;
  Include(Self.chk_allbook.CheckedChanged, Self.chk_allbook_CheckedChanged);
  // 
  // lall_invoice
  // 
  Self.lall_invoice.Font := System.Drawing.Font.Create('Times New Roman', 9.75, 
      System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lall_invoice.Location := System.Drawing.Point.Create(64, 5);
  Self.lall_invoice.Name := 'lall_invoice';
  Self.lall_invoice.Size := System.Drawing.Size.Create(72, 20);
  Self.lall_invoice.TabIndex := 1;
  Self.lall_invoice.Text := 'all book(s) ...';
  // 
  // Panel3
  // 
  Self.Panel3.BackColor := System.Drawing.Color.Teal;
  Self.Panel3.Controls.Add(Self.txtsearch);
  Self.Panel3.Controls.Add(Self.Btnsearch);
  Self.Panel3.Location := System.Drawing.Point.Create(160, 24);
  Self.Panel3.Name := 'Panel3';
  Self.Panel3.Size := System.Drawing.Size.Create(32, 336);
  Self.Panel3.TabIndex := 3;
  // 
  // txtsearch
  // 
  Self.txtsearch.BackColor := System.Drawing.Color.Teal;
  Self.txtsearch.BorderStyle := System.Windows.Forms.BorderStyle.None;
  Self.txtsearch.Font := System.Drawing.Font.Create('Times New Roman', 12, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.txtsearch.ForeColor := System.Drawing.Color.White;
  Self.txtsearch.Location := System.Drawing.Point.Create(8, 208);
  Self.txtsearch.Multiline := True;
  Self.txtsearch.Name := 'txtsearch';
  Self.txtsearch.Size := System.Drawing.Size.Create(16, 115);
  Self.txtsearch.TabIndex := 1;
  Self.txtsearch.Text := 'SEARCH';
  Self.txtsearch.TextAlign := System.Windows.Forms.HorizontalAlignment.Center;
  // 
  // Btnsearch
  // 
  Self.Btnsearch.BackColor := System.Drawing.SystemColors.Control;
  Self.Btnsearch.Enabled := False;
  Self.Btnsearch.Image := (System.Drawing.Image(resources.GetObject('Btnsearch.Image')));
  Self.Btnsearch.Location := System.Drawing.Point.Create(5, 16);
  Self.Btnsearch.Name := 'Btnsearch';
  Self.Btnsearch.Size := System.Drawing.Size.Create(24, 74);
  Self.Btnsearch.TabIndex := 0;
  Include(Self.Btnsearch.Click, Self.Btnsearch_Click);
  // 
  // Panel2
  // 
  Self.Panel2.BackColor := System.Drawing.SystemColors.Control;
  Self.Panel2.Controls.Add(Self.lcondition);
  Self.Panel2.Controls.Add(Self.Chkcond);
  Self.Panel2.Controls.Add(Self.cmbfather);
  Self.Panel2.Controls.Add(Self.cmbfirst);
  Self.Panel2.Controls.Add(Self.Btnclear);
  Self.Panel2.Controls.Add(Self.lphoneno);
  Self.Panel2.Controls.Add(Self.lcity);
  Self.Panel2.Controls.Add(Self.lcountry);
  Self.Panel2.Controls.Add(Self.txtphone);
  Self.Panel2.Controls.Add(Self.lfather);
  Self.Panel2.Controls.Add(Self.lfirst);
  Self.Panel2.Controls.Add(Self.lname);
  Self.Panel2.Controls.Add(Self.cmbname);
  Self.Panel2.Controls.Add(Self.cmbcity);
  Self.Panel2.Controls.Add(Self.cmbcountry);
  Self.Panel2.Location := System.Drawing.Point.Create(8, 56);
  Self.Panel2.Name := 'Panel2';
  Self.Panel2.Size := System.Drawing.Size.Create(144, 304);
  Self.Panel2.TabIndex := 6;
  // 
  // lcondition
  // 
  Self.lcondition.Font := System.Drawing.Font.Create('Times New Roman', 9.75, 
      System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lcondition.ForeColor := System.Drawing.Color.Firebrick;
  Self.lcondition.Location := System.Drawing.Point.Create(40, 8);
  Self.lcondition.Name := 'lcondition';
  Self.lcondition.Size := System.Drawing.Size.Create(104, 20);
  Self.lcondition.TabIndex := 1;
  Self.lcondition.Text := 'condition - ''OR''';
  Self.lcondition.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
  // 
  // Chkcond
  // 
  Self.Chkcond.Location := System.Drawing.Point.Create(8, 8);
  Self.Chkcond.Name := 'Chkcond';
  Self.Chkcond.Size := System.Drawing.Size.Create(16, 16);
  Self.Chkcond.TabIndex := 0;
  Include(Self.Chkcond.CheckedChanged, Self.Chkcond_CheckedChanged);
  // 
  // cmbfather
  // 
  Self.cmbfather.Location := System.Drawing.Point.Create(8, 120);
  Self.cmbfather.Name := 'cmbfather';
  Self.cmbfather.Size := System.Drawing.Size.Create(128, 21);
  Self.cmbfather.TabIndex := 7;
  Include(Self.cmbfather.SelectedIndexChanged, Self.cmbfather_SelectedIndexChanged);
  // 
  // cmbfirst
  // 
  Self.cmbfirst.Location := System.Drawing.Point.Create(8, 80);
  Self.cmbfirst.Name := 'cmbfirst';
  Self.cmbfirst.Size := System.Drawing.Size.Create(128, 21);
  Self.cmbfirst.TabIndex := 5;
  Include(Self.cmbfirst.SelectedIndexChanged, Self.cmbfirst_SelectedIndexChanged);
  // 
  // Btnclear
  // 
  Self.Btnclear.Font := System.Drawing.Font.Create('Times New Roman', 11.25, 
      System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.Btnclear.Location := System.Drawing.Point.Create(8, 272);
  Self.Btnclear.Name := 'Btnclear';
  Self.Btnclear.Size := System.Drawing.Size.Create(128, 22);
  Self.Btnclear.TabIndex := 14;
  Self.Btnclear.Text := 'clear all ';
  Include(Self.Btnclear.Click, Self.Btnclear_Click);
  // 
  // lphoneno
  // 
  Self.lphoneno.Font := System.Drawing.Font.Create('Times New Roman', 9.75, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lphoneno.Location := System.Drawing.Point.Create(8, 224);
  Self.lphoneno.Name := 'lphoneno';
  Self.lphoneno.Size := System.Drawing.Size.Create(80, 16);
  Self.lphoneno.TabIndex := 12;
  Self.lphoneno.Text := 'phone  ';
  Self.lphoneno.TextAlign := System.Drawing.ContentAlignment.MiddleLeft;
  // 
  // lcity
  // 
  Self.lcity.Font := System.Drawing.Font.Create('Times New Roman', 9.75, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lcity.Location := System.Drawing.Point.Create(8, 184);
  Self.lcity.Name := 'lcity';
  Self.lcity.Size := System.Drawing.Size.Create(56, 16);
  Self.lcity.TabIndex := 10;
  Self.lcity.Text := 'city ';
  Self.lcity.TextAlign := System.Drawing.ContentAlignment.MiddleLeft;
  // 
  // lcountry
  // 
  Self.lcountry.Font := System.Drawing.Font.Create('Times New Roman', 9.75, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lcountry.Location := System.Drawing.Point.Create(8, 144);
  Self.lcountry.Name := 'lcountry';
  Self.lcountry.Size := System.Drawing.Size.Create(56, 16);
  Self.lcountry.TabIndex := 8;
  Self.lcountry.Text := 'country ';
  Self.lcountry.TextAlign := System.Drawing.ContentAlignment.MiddleLeft;
  // 
  // txtphone
  // 
  Self.txtphone.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.txtphone.Location := System.Drawing.Point.Create(8, 240);
  Self.txtphone.Name := 'txtphone';
  Self.txtphone.Size := System.Drawing.Size.Create(128, 20);
  Self.txtphone.TabIndex := 13;
  Self.txtphone.Text := '';
  Include(Self.txtphone.KeyPress, Self.txtphone_KeyPress);
  // 
  // lfather
  // 
  Self.lfather.Font := System.Drawing.Font.Create('Times New Roman', 9.75, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lfather.Location := System.Drawing.Point.Create(8, 104);
  Self.lfather.Name := 'lfather';
  Self.lfather.Size := System.Drawing.Size.Create(96, 16);
  Self.lfather.TabIndex := 6;
  Self.lfather.Text := 'father name';
  Self.lfather.TextAlign := System.Drawing.ContentAlignment.MiddleLeft;
  // 
  // lfirst
  // 
  Self.lfirst.Font := System.Drawing.Font.Create('Times New Roman', 9.75, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lfirst.Location := System.Drawing.Point.Create(8, 64);
  Self.lfirst.Name := 'lfirst';
  Self.lfirst.Size := System.Drawing.Size.Create(64, 16);
  Self.lfirst.TabIndex := 4;
  Self.lfirst.Text := 'first name ';
  Self.lfirst.TextAlign := System.Drawing.ContentAlignment.MiddleLeft;
  // 
  // lname
  // 
  Self.lname.Font := System.Drawing.Font.Create('Times New Roman', 9.75, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lname.ImageAlign := System.Drawing.ContentAlignment.MiddleLeft;
  Self.lname.Location := System.Drawing.Point.Create(8, 24);
  Self.lname.Name := 'lname';
  Self.lname.Size := System.Drawing.Size.Create(64, 16);
  Self.lname.TabIndex := 2;
  Self.lname.Text := 'name ';
  Self.lname.TextAlign := System.Drawing.ContentAlignment.MiddleLeft;
  // 
  // cmbname
  // 
  Self.cmbname.Location := System.Drawing.Point.Create(8, 40);
  Self.cmbname.Name := 'cmbname';
  Self.cmbname.Size := System.Drawing.Size.Create(128, 21);
  Self.cmbname.TabIndex := 3;
  Include(Self.cmbname.SelectedIndexChanged, Self.cmbname_SelectedIndexChanged);
  // 
  // cmbcity
  // 
  Self.cmbcity.Location := System.Drawing.Point.Create(8, 200);
  Self.cmbcity.Name := 'cmbcity';
  Self.cmbcity.Size := System.Drawing.Size.Create(128, 21);
  Self.cmbcity.TabIndex := 11;
  Include(Self.cmbcity.SelectedIndexChanged, Self.cmbcity_SelectedIndexChanged);
  // 
  // cmbcountry
  // 
  Self.cmbcountry.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.cmbcountry.Items.AddRange(TSystem_ObjectArray.Create('Afghanistan', 'Albania', 
          'Algeria', 'American Samoa', 'Andorra', 'Angola', 'Anguilla', 'Antarctica', 
          'Antigua and Barbuda', 'Argentina', 'Armenia', 'Aruba', 'Australia', 
          'Austria', 'Azerbaijan', 'Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 
          'Belarus', 'Belgium', 'Belize', 'Benin', 'Bermuda', 'Bhutan', 'Bolivia', 
          'Bosnia and Herzegovina', 'Botswana', 'Bouvet Island', 'Brazil', 'British Indian Ocean Territory', 
          'Brunei', 'Bulgaria', 'Burkina Faso', 'Burundi', 'Cte d''Ivoire', 
          'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Cayman Islands', 'Central African Republic', 
          'Chad', 'Channel Islands', 'Chile', 'China', 'Christmas Island', 'Cocos (Keeling) Islands', 
          'Colombia', 'Comoros', 'Congo', 'Congo (DRC)', 'Cook Islands', 'Coral Sea Islands', 
          'Costa Rica', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 
          'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 
          'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 
          'Ethiopia', 'Falkland Islands ', 'Faroe Islands', 'Fiji Islands', 'Finland', 
          'France', 'France, Metropolitan', 'French Guiana', 'French Polynesia', 
          'French Southern and Antarctic Lands', 'Gabon', 'Gambia', 'Georgia', 
          'Germany', 'Ghana', 'Gibraltar', 'Greece', 'Greenland', 'Grenada', 
          'Guadeloupe', 'Guam', 'Guatemala', 'Guernsey', 'Guinea', 'Guinea-Bissau', 
          'Guyana', 'Haiti', 'Heard Island and McDonald Islands', 'Honduras', 
          'Hong Kong SAR', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iran', 
          'Iraq', 'Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jersey', 
          'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'Korea', 'Kuwait', 'Kyrgyzstan', 
          'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 
          'Lithuania', 'Luxembourg', 'Macau SAR', 'Macedonia', 'Madagascar', 
          'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Man, Isle of', 
          'Marshall Islands', 'Martinique', 'Mauritania', 'Mauritius', 'Mayotte', 
          'Mexico', 'Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montserrat', 
          'Morocco', 'Mozambique', 'Myanmar', 'Namibia', 'Nauru', 'Nepal', 'Netherlands Antilles', 
          'Netherlands', 'New Caledonia', 'New Zealand', 'Nicaragua', 'Niger', 
          'Nigeria', 'Niue', 'Norfolk Island', 'North Korea', 'Northern Mariana Islands', 
          'Norway', 'Oman', 'Pakistan', 'Palau', 'Panama', 'Papua New Guinea', 
          'Paraguay', 'Peru', 'Philippines', 'Pitcairn Islands', 'Poland', 'Portugal', 
          'Puerto Rico', 'Qatar', 'Reunion', 'Romania', 'Russia', 'Rwanda', 'Sao Tome and Principe', 
          'Samoa', 'San Marino', 'Saudi Arabia', 'Senegal', 'Seychelles', 'Sierra Leone', 
          'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 
          'South Africa', 'South Georgia and the South Sandwich Islands', 'Spain', 
          'Sri Lanka', 'St. Helena', 'St. Kitts and Nevis', 'St. Lucia', 'St. Pierre and Miquelon', 
          'St. Vincent and the Grenadines', 'Sudan', 'Suriname', 'Svalbard and Jan Mayen', 
          'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Taiwan', 'Tajikistan', 
          'Tanzania', 'Thailand', 'Togo', 'Tokelau', 'Tonga', 'Trinidad and Tobago', 
          'Tunisia', 'Turkey', 'Turkmenistan', 'Turks and Caicos Islands', 'Tuvalu', 
          'U.S. Minor Outlying Islands', 'Uganda', 'Ukraine', 'United Arab Emirates', 
          'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 
          'Vatican City', 'Venezuela', 'Viet Nam', 'Virgin Islands', 'British Virgin Islands', 
          'Wallis and Futuna', 'Yemen', 'Yugoslavia', 'Zambia', 'Zimbabwe', 'LIBAN'));
  Self.cmbcountry.Location := System.Drawing.Point.Create(8, 160);
  Self.cmbcountry.Name := 'cmbcountry';
  Self.cmbcountry.Size := System.Drawing.Size.Create(128, 21);
  Self.cmbcountry.TabIndex := 9;
  Include(Self.cmbcountry.SelectedIndexChanged, Self.cmbcountry_SelectedIndexChanged);
  // 
  // OleDbConnection1
  // 
  Self.OleDbConnection1.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\work_Delphinet\data\work_Delphi'+ 
  'net.mdb;Persist Security Info=False';
  // 
  // Tbook_search
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(664, 431);
  Self.ControlBox := False;
  Self.Controls.Add(Self.Panel1);
  Self.FormBorderStyle := System.Windows.Forms.FormBorderStyle.FixedSingle;
  Self.MaximizeBox := False;
  Self.MinimizeBox := False;
  Self.Name := 'Tbook_search';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.Manual;
  Self.Text := 'book_search';
  Include(Self.Load, Self.Tbook_search_Load);
  Self.Panel1.ResumeLayout(False);
  Self.Panel5.ResumeLayout(False);
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).EndInit;
  Self.Panel4.ResumeLayout(False);
  Self.Panel3.ResumeLayout(False);
  Self.Panel2.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure Tbook_search.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor Tbook_search.Create;
var
vleft: Integer;
vtop: Integer;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //

	// Move
  vleft := book_note.Tbook_note.booknote_left + book_note.Tbook_note.booknote_width - Self.Width;
	vtop := book_note.Tbook_note.booknote_top;
 	Self.Location := System.Drawing.Point.Create(vleft, vtop);
  
 //resize
  Self.Btnok.Top := (self.Panel5.Height - Self.Btnok.Height) div 2;
  self.Btncancel.Top := self.Btnok.Top;
  
  self.Btnsearch.Left := (self.Panel3.Width - self.Btnsearch.Width) div 2;

  self.Pic_line011.Top := self.Btnok.Top + ((self.Btnok.Height - (self.Pic_line011.Height * 3)) div 4);
 	self.Pic_line012.Top := self.Pic_line011.Top + self.Pic_line011.Height + ((self.Btnok.Height - (self.Pic_line011.Height * 3)) div 4);
 	self.Pic_line013.Top := self.Pic_line012.Top + self.Pic_line012.Height + ((self.Btnok.Height - (self.Pic_line011.Height * 3)) div 4);

 	self.Pic_line011.Left := (self.Btnok.Left - self.Pic_line011.Width) div 2;
 	self.Pic_line012.Left := self.Pic_line011.Left;
 	self.Pic_line013.Left := self.Pic_line011.Left;


end;

class function Tbook_search.Showbooksearch: System.Windows.Forms.DialogResult;
begin
  with Tbook_search.Create do
    Result := ShowDialog;
end;
 procedure Tbook_search.Tbook_search_Load(sender: System.Object; e: System.EventArgs);
begin

  s_flag := False;
	searchflg := False;
  sub_clearall;

  self.lbfound.Text := '';
  //booknote_type := 'find';

	if (book_note.Tbook_note.booknote_type = 'find') then
			self.Text := 'search, book note ...';

	if (book_note.Tbook_note.booknote_type = 'edit') then
		 	self.Text := 'edit, book note ...';

	self.chk_allbook.Checked := True;

	sub_load('name');
 	sub_load('first');
 	sub_load('father');
 	sub_load('city');

 	sub_search('', '', '', '', '', '');

end;

//add data to comboboxes
procedure Tbook_search.sub_load(v_field: string);
var
i: Integer;
begin
    vselect := System.Data.OleDb.OleDbCommand.Create;
    vda := System.Data.OleDb.OleDbDataAdapter.Create;
    vdset := System.Data.DataSet.Create;

	if (v_field = 'name') then
    	vselect.CommandText := 'SELECT DISTINCT Trim(name) AS vname FROM book WHERE (Trim(name) <> "") ORDER BY  Trim(name)';
	if (v_field = 'first') then
      vselect.CommandText := 'SELECT DISTINCT Trim(first_name) AS vfirst FROM book WHERE (Trim(first_name) <>"")ORDER BY Trim(first_name)';
	if (v_field = 'father') then
      vselect.CommandText := 'SELECT DISTINCT Trim(father_name) AS vfather FROM book WHERE (Trim(father_name) <>"")ORDER BY Trim(father_name)';
	if (v_field = 'city') then
			vselect.CommandText := 'SELECT DISTINCT Trim(city) AS vcity FROM book WHERE (Trim(city)<>"")ORDER BY Trim(city)';

    vselect.Connection := Self.OleDbConnection1;
    vda.SelectCommand := vselect;
    vdset.EnforceConstraints := False;
    Try
      //Open the connection.
      Self.OleDbConnection1.Open();
      vda.Fill(vdset, 'book');
    finally
       //Turn constraint checking back on.
       vdset.EnforceConstraints := True;
       //Close the connection
       Self.OleDbConnection1.Close();
    end;
 
    if (vdset.Tables['book'].Rows.Count > 0) then
     begin
        for i := 0 to (vdset.Tables['book'].Rows.Count - 1) do
          begin
		  			if (v_field = 'name') then
		  					Self.cmbname.Items.Add(vdset.Tables['book'].Rows[i].Item['vname'].ToString().Trim());
		  	    if (v_field = 'first') then
		  					Self.cmbfirst.Items.Add(vdset.Tables['book'].Rows[i].Item['vfirst'].ToString().Trim());
		  	    if (v_field = 'father') then
				 			  Self.cmbfather.Items.Add(vdset.Tables['book'].Rows[i].Item['vfather'].ToString().Trim());
		  	    if (v_field = 'city') then
			  				Self.cmbcity.Items.Add(vdset.Tables['book'].Rows[i].Item['vcity'].ToString().Trim());

					end;

		  end;
end;

procedure Tbook_search.Chkcond_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin

end;

procedure Tbook_search.cmbname_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
begin
    if (s_flag = True) then sub_check;
end;

procedure Tbook_search.sub_check;
begin
    if (self.chk_allbook.Checked = True) then self.chk_allbook.Checked := False;
    if (self.Btnsearch.Enabled = False) then self.Btnsearch.Enabled := True;
end;

procedure Tbook_search.cmbfirst_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
begin
     if (s_flag = True) then sub_check;
end;
procedure Tbook_search.cmbfather_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
    if (s_flag = True) then sub_check;
end;

procedure Tbook_search.cmbcountry_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
    if (s_flag = True) then sub_check;
end;

procedure Tbook_search.cmbcity_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
begin
    if (s_flag = True) then sub_check;
end;

procedure Tbook_search.txtphone_KeyPress(sender: System.Object; e: System.Windows.Forms.KeyPressEventArgs);
begin
    if (s_flag = True) then sub_check;
end;

procedure Tbook_search.chk_allbook_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  if (s_flag = True and self.chk_allbook.Checked = True) then
			begin
		 		if (self.Btnsearch.Enabled = False ) then self.Btnsearch.Enabled := True;
			end;
end;

procedure Tbook_search.Btnclear_Click(sender: System.Object; e: System.EventArgs);
begin
    sub_clearall;
end;
 
procedure Tbook_search.sub_clearall;
begin
  self.cmbname.set_SelectedIndex(-1);
  self.cmbfirst.set_SelectedIndex(-1);
  self.cmbfather.set_SelectedIndex(-1);
  self.cmbcountry.set_SelectedIndex(-1);
  self.cmbcity.set_SelectedIndex(-1);
  self.txtphone.Text := '';
  if (self.Btnsearch.Enabled = True) then self.Btnsearch.Enabled := False;

end;


procedure Tbook_search.Btnsearch_Click(sender: System.Object; e: System.EventArgs);
begin
     searchflg := True;

		 if (Self.chk_allbook.Checked = True) then
				sub_search('', '', '', '', '', '');
		 if (Self.chk_allbook.Checked = False) then
				sub_search(Self.cmbname.Text.Trim(), Self.cmbfirst.Text.Trim(), Self.cmbfather.Text.Trim(), Self.cmbcountry.Text.Trim(), Self.cmbcity.Text.Trim(), Self.txtphone.Text.Trim());

end;

procedure Tbook_search.sub_search(v_name: string; v_firstname: string; v_fathername: string; v_country: string; v_city: string; v_phone: string);
var
 vfound : Integer;
begin
    vselect := System.Data.OleDb.OleDbCommand.Create;
    vda := System.Data.OleDb.OleDbDataAdapter.Create;
    vdset := System.Data.DataSet.Create;

    if  (self.chk_allbook.Checked = True) then
         vselect.CommandText := 'SELECT bookid,alternativePhone, city, country, father_name, fax, first_name, homephone, mobilephone, name, sex, workphone FROM book WHERE (name <> "") ORDER BY name, first_name, father_name';
    if  (self.chk_allbook.Checked = False) then
         vselect.CommandText := 'SELECT bookid,alternativePhone, city, country, father_name, fax, first_name, homephone, mobilephone, name, sex, workphone FROM book WHERE ((name <> "") And (Trim(name) = "' + v_name + '") Or (Trim(first_name) =  "' + v_firstname + '") Or (Trim(father_name)  = "' + v_fathername + '") Or (Trim(country)  = "' + v_country + '") Or (Trim(city)  = "' + v_city + '") Or ((Trim(homephone) =  "' + v_phone + '") Or (Trim(workphone) =  "' + v_phone + '") Or (Trim(mobilephone) =  "' + v_phone + '") Or (Trim(alternativePhone) =  "' + v_phone + '") Or (Trim(fax) =  "' + v_phone + '"))) ORDER BY name, first_name, father_name';


        vselect.Connection := Self.OleDbConnection1;
        vda.SelectCommand := vselect;
        vdset.EnforceConstraints := False;
        Try
          //Open the connection.
          Self.OleDbConnection1.Open();
          vda.Fill(vdset, 'book');
        finally
          //Turn constraint checking back on.
          vdset.EnforceConstraints := True;
          //Close the connection
          Self.OleDbConnection1.Close();
        end;
          vfound := vdset.Tables['book'].Rows.Count;
          self.DataGrid1.DataSource := vdset;
          self.DataGrid1.DataMember := 'book';
          s_flag := True;

          if (searchflg = true) then
			    begin
				    Self.Btnsearch.Enabled := True;
				    Self.btnclear_Click(btnclear, nil);
				    searchflg := False;
			    end;

          if  (self.chk_allbook.Checked = True) then
               self.lbfound.Text := vfound.ToString + ' - item(s) found';

          if  (self.chk_allbook.Checked = False) then
              self.lbfound.Text := vfound.ToString + ' - item(s) found';

			    self.lbfound.Focus();
end;

procedure Tbook_search.sub_select;
var
vvrec: Integer;
begin
    vselect := System.Data.OleDb.OleDbCommand.Create;
    vda := System.Data.OleDb.OleDbDataAdapter.Create;
    vdset := System.Data.DataSet.Create;

    vselect.CommandText := 'SELECT  bookid, country, father_name, first_name, name, sex FROM book WHERE (name <> "") ORDER BY bookid';
 
    vselect.Connection := Self.OleDbConnection1;
    vda.SelectCommand := vselect;
    vdset.EnforceConstraints := False;
    Try
      //Open the connection.
      Self.OleDbConnection1.Open();
      vda.Fill(vdset, 'book');
    finally
       //Turn constraint checking back on.
       vdset.EnforceConstraints := True;
       //Close the connection
       Self.OleDbConnection1.Close();
    end;

    if (vdset.Tables['book'].Rows.Count > 0) then
       begin
         for vvrec := 0 to (vdset.Tables['book'].Rows.Count - 1) do
            begin
              if (vdset.Tables['book'].Rows[vvrec].Item['bookid'].ToString = vitem_grid) then
                 begin
                   v_recno := vvrec;
                   exit;
                 end;
            end;
       end;
end;

procedure Tbook_search.DataGrid1_Click(sender: System.Object; e: System.EventArgs);
begin
   vitem_grid := self.DataGrid1.Item[self.DataGrid1.CurrentRowIndex,0].ToString;
  self.Btnok.Enabled := True;
end;

procedure Tbook_search.DataGrid1_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
   vitem_grid := self.DataGrid1.Item[self.DataGrid1.CurrentRowIndex,0].ToString;
  self.Btnok.Enabled := True;
end;

class function Tbook_search.book_v_recno: Integer;
begin
    result := v_recno;
 end;

class function Tbook_search.book_findedit_Flag: string;
 begin
    result := findedit_Flag;
 end;


procedure Tbook_search.Btnok_Click(sender: System.Object; e: System.EventArgs);
begin
   sub_select;
	findedit_Flag  := 'ok';

	if (book_note.Tbook_note.booknote_type = 'find') then
  begin
			close;
      book_note.Tbook_note.ActiveForm.Refresh;
      book_note.Tbook_note.ActiveForm.Activate;
  end;
  if (book_note.Tbook_note.booknote_type = 'edit') then
  begin
			close;
      book_note.Tbook_note.ActiveForm.Refresh;
      book_note.Tbook_note.ActiveForm.Activate;
  end;

end;

procedure Tbook_search.Btncancel_Click(sender: System.Object; e: System.EventArgs);
begin
    findedit_Flag  := 'cancel';
    close;
    book_note.Tbook_note.ActiveForm.Refresh;
    book_note.Tbook_note.ActiveForm.Activate;

end;


end.
